// simple.vert

#extension GL_EXT_gpu_shader4 : enable

// vertex shader of carttond shading

uniform int lightNumberCartoon;
varying float s;
varying float t;

void main(void)
{
    gl_TexCoord[0] = gl_MultiTexCoord0;
    
    // _WŌvZ 
    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);

    float lgtdot = 0.0;
    float specular = 0.0;

    gl_Position = ftransform();

    float alpha = gl_FrontLightProduct[0].ambient[3];

    // @ƎxNgƂ̓
    vec3  normal = normalize(gl_NormalMatrix * gl_Normal);
    
    vec3  eye = - normalize(vec3(gl_ModelViewMatrix * gl_Vertex));
    float eyedot = dot(eye, normal);

    float dis = length(position);

    for (int i = 0; i < lightNumberCartoon; i++){
	vec3 lightVec = normalize(gl_LightSource[i].position.xyz - position * gl_LightSource[i].position[3]);
	
	// ʒuWWϊ
		
	// @ƌxNgƂ̓(sp)
	vec3  light = normalize(lightVec);
	
	float diffuse = dot(lightVec, normal);
	if (diffuse > 0.0){
	    // ˃xNgɂXyL[ 
	    vec3 viewVec = normalize(-position);
	    vec3 reflectVec = reflect(-lightVec, normal);
	    lgtdot += dot(light, normal)
		* gl_LightSource[i].diffuse[0];
	    specular += pow(max(dot(viewVec, reflectVec), 0.0), 
			   gl_FrontMaterial.shininess)
		* gl_LightSource[i].diffuse[0];
	}
    }

    // eNX`WɊ蓖Ă
    s = lgtdot * 0.8 + specular;//
    if (s > 1.0) s = 1.0;
    // !! _TO_DO !! ␳ǂH
    t = eyedot * eyedot / (1.0/* + min(dis/10.0, 1.0)*/);
    
    // eNX`WɊ蓖Ă
    //gl_TexCoord[1].s = lgtdot * 0.8 + specular;//
    //if (gl_TexCoord[1].s > 1.0) gl_TexCoord[1].s = 1.0;
    // !! _TO_DO !! ␳ǂH
    //gl_TexCoord[1].t = eyedot * eyedot / (1.0/* + min(dis/10.0, 1.0)*/);
}
